'*******************************************************************************
'*************                                                       ***********
'*************                 ***********
'*************                 74HC595                      ***********
'*************     (  3  )   ***********
'*************                                                       ***********
'*******************************************************************************

' : ATMEGA8A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'*******************************************************************************
'-------------------------------------------------------------------------------
'---------------            ----------------
'-------------------------------------------------------------------------------
  $regfile = "m8def.dat" : $crystal = 8000000 : $hwstack = 40 : $swstack = 16 : $framesize = 32
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-----------------             -------------------
'-------------------------------------------------------------------------------
_:       '  ,  
'-------------------------------------------------------------------------------

  Dim _ As Byte       ' ,     
  _ = 0       '  _ = 1 ,   ,  _ = 0 ,  A

'---------------------------------------------

  Const _timer2 = 64
  Const _ = 8       '   

'---------------------------------------------

  Const _ = 200       '      LED   _(n) = 1
  Const ___ = 100       '      LED   _(n) = 1

'---------------------------------------------

  Const __led = 1       '     (  OCR2)
  Const __led = 255       '     (  OCR2)
  Const ___led = 5       '     LED 

'---------------------------------------------

  Const _ = 50
  Const __ = 200       ' ,     "Waitms"

'-------------------------------------------------------------------------------

  Dim _led As Byte       ' ,      (     )
  Dim _ As Byte       '      
  Dim _stop As Byte       '  _stop = 1,  
  Dim _ As Byte       ' ,    74HC595
  Dim _led_1 As Word       ' ,  1- 
  Dim _led_2 As Word       ' ,  2- 
  Dim _led As Byte       ' ,    LED 
  Dim _ As Byte       '     LED 
  Dim _ As Word       '       
  Dim _ As Word       '   
  Dim _ As Byte       ' ,   
  Dim _word_1 As Word       ' ,   
  Dim _word_2 As Word       ' ,   
  Dim __led As Byte       ' ,   
  Dim __led As Byte       ' ,     
  Dim __led As Word       ' ,    
  Dim ___led As Word       ' ,      (     )
  Dim (_) As Byte       '  6- 
  Dim (_) As Byte       '     
  Dim _(_) As Byte       '   6- 
  Dim _(_) As Byte       '   
  Dim _(_) As Byte       '      4- 
  Dim _(_) As Byte       ' ,       __(n) = 1
  Dim __(_) As Byte       '      

'-------------------------------------------------------------------------------
'---------------         LED      -----------------
'-------------------------------------------------------------------------------

  Config Portd.7 = Output       '  SH_CP  ( )
   Alias Portd.7

  Config Portb.0 = Output       '  DS  ()
   Alias Portb.0

  Config Portd.6 = Output       '  ST_CP ()
   Alias Portd.6

'-------------------------------------------------------------------------------
'-----------         TIMER2     ----------
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'------------         LED      -----------
'-------------------------------------------------------------------------------

  Config Timer2 = Timer , Prescale = _timer2       '   

'-------------------------------------------------------------------------------
'-----------         TIMER2     ----------
'-------------------------------------------------------------------------------

  On Compare2 __led       '    
  On Timer2 __timer2       '    

'-------------------------------------------------------------------------------

  Declare Sub __74hc595()
  Declare Sub __led()
  Declare Sub _7seg_led()
  Declare Sub __timer2()

'-------------------------------------------------------------------------------
'------------------------            ------------------------
'-------------------------------------------------------------------------------

  Enable Timer2       '     

  Enable Compare2

  Enable Interrupts       '  

'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _word_1 = _
  Wait 2
'-------------------------------------------------------------------------------
  Do : Nop
'-------------------------------------------------------------------------------





    If _stop = 0 Then

        Decr _word_1

        If _word_1 = 0 Then       '_word_1 = _

            _stop = 1
            _word_1 = _

            _(1) = 1
'            _(2) = 1
            _(3) = 1
'            _(4) = 1
            _(5) = 1
'            _(6) = 1
            _(7) = 1
'            _(8) = 1

            _(1) = 1
            _(2) = 1
            _(3) = 1
            _(4) = 1
            _(5) = 1
            _(6) = 1
            _(7) = 1
            _(8) = 1

'            _(1) = 1
'            _(2) = 1
'            _(3) = 1
'            _(4) = 1
'            _(5) = 1
'            _(6) = 1
'            _(5) = 1
'            _(6) = 1

            __(1) = 1 : _(1) = 10
            __(2) = 1 : _(2) = 11
            __(3) = 1 : _(3) = 12
            __(4) = 1 : _(4) = 10

            __(5) = 1 : _(5) = 12
            __(6) = 1 : _(6) = 10
            __(7) = 1 : _(7) = 15
            __(8) = 1 : _(8) = 14

           Wait 2
           Config Watchdog = 2048
           Start Watchdog
           Wait 2

        End If

        _led_1 = _word_1



        Incr _word_2

        If _word_2 > 9999 Then _word_2 = 0

        _led_2 = _word_2

    End If

'-------------------------------------------------------------------------------
    Waitms __
'-------------------------------------------------------------------------------
  Loop
 End
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************    TIMER0 ****************
'*****************   2,048 ms ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __timer2:
'-------------------------------------------------------------------------------
    rCall _7seg_led
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _7seg_led:
'-------------------------------------------------------------------------------
'---      LED  (  ,  , ,      )  ---
'-------------------------------------------------------------------------------
    Incr __led
    If __led = ___led Then
        __led = 0
        If _ = 0 Then Incr _led Else Decr _led
        If _led = __led Then _ = 1
        If _led = __led Then _ = 0
    End If
'-------------------------------------------------------------------------------
'--------------      LED     ---------------
'-------------------------------------------------------------------------------
    Ocr2 = _led
'-------------------------------------------------------------------------------
'------       "_led_string"     ------
'-------------------------------------------------------------------------------

    __led = _led_1

    ___led = __led


    For _led = 4 To 1 Step -1       '       4 
        __led = ___led Mod 10
        (_led) = __led       '
        ___led = ___led / 10
    Next



    __led = _led_2

    ___led = __led


    For _led = 8 To 5 Step -1       '       4 
        __led = ___led Mod 10
        (_led) = __led       '
        ___led = ___led / 10
    Next


'-------------------------------------------------------------------------------
'----    ,         -----
'-------------------------------------------------------------------------------
'-----           7-seg LED     -----
'-------------------------------------------------------------------------------
    Incr _

    If _ > _ Then _ = 0       '    
'-------------------------------------------------------------------------------
'      ,     
'-------------------------------------------------------------------------------
'----------------------------       --------------------------
'-------------------------------------------------------------------------------
    Incr _

    If _ > _ Then _ = 1       '  
'-------------------------------------------------------------------------------
'-----------------------        ---------------------
'-------------------------------------------------------------------------------
        If __(_) = 1 Then

            Select Case _
              Case 1 To 4
                If _ = 1 Then
                    __led = Lookup(_(_) , _ok)       '  _  1 - 4 
                  Else
                    __led = Lookup(_(_) , _oa)       '  _  1 - 4 
                End If
              Case 5 To 8
                If _ = 1 Then
                    __led = Lookup(_(_) , _ok)       '  _  1 - 4 
                  Else
                    __led = Lookup(_(_) , _oa)       '  _  1 - 4 
                End If
            End Select
'-------------------------------------------------------------------------------
'----------------------         ----------------------
'-------------------------------------------------------------------------------
          Else
'-------------------------------------------------------------------------------
'-------          ,     ------
'-------------------------------------------------------------------------------
            __led = (_)

              Select Case _
                Case 1 To 4
                  If _ = 1 Then
                      __led = Lookup(__led , _ok)       '     ,    1 - 4 
                    Else
                      __led = Lookup(__led , _oa)       '     ,    1 - 4 
                  End If
                Case 5 To 8
                  If _ = 1 Then
                      __led = Lookup(__led , _ok)       '     ,    1 - 4 
                    Else
                      __led = Lookup(__led , _oa)       '     ,    1 - 4 
                  End If
              End Select

        End If
'-------------------------------------------------------------------------------
'-------------    ,        -------------
'-------------------------------------------------------------------------------
      If _(_) = 1 Then
              __led = __led Xor &B00000001
      End If
'-------------------------------------------------------------------------------
'   "     ,     "
'-------------------------------------------------------------------------------
'    End If
'-------------------------------------------------------------------------------
'---------------------            ------------------------
'-------------------------------------------------------------------------------
    rcall __74hc595
'-------------------------------------------------------------------------------
'----------------              ----------------
'-------------------------------------------------------------------------------
    If _(_) = 1 And _ > ___ Or _(_) = 1 Then       '       > 200
        If _ = 1 Then __led = Lookup(16 , _ok)       '     
      Else       '  (  ,   < 200)
        If _ = 1 Then
            __led = Lookup(_ , _ok)       '     
          Else
            __led = Lookup(_ , _oa)       '     
        End If
    End If
'-------------------------------------------------------------------------------
'---------------------            ----------------------
'-------------------------------------------------------------------------------
    rcall __74hc595
'-------------------------------------------------------------------------------
'-----------------      LED    -----------------
'-------------------------------------------------------------------------------
       = 1
'      Waitus 5
       = 0
'-------------------------------------------------------------------------------
'---------------------    ,     -------------------
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  __74hc595:
'-------------------------------------------------------------------------------
   For _ = 0 To 7       '       
     If __led.7 = 0 Then  = 0 Else  = 1
          = 1       '          (  )
'         Waitus 5
          = 0
         Shift __led , Left , 1       '        
   Next _

    = 0
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  __led:
'-------------------------------------------------------------------------------
    If _ = 1 Then
        __led = Lookup(0 , _ok)       '     
      Else
        __led = Lookup(0 , _oa)       '     
    End If
'-------------------------------------------------------------------------------
'---------------------            ----------------------
'-------------------------------------------------------------------------------
    rcall __74hc595
'-------------------------------------------------------------------------------
'-----------------      LED    -----------------
'-------------------------------------------------------------------------------
  ___led:
'-------------------------------------------------------------------------------
       = 1
'      Waitus 5
       = 0
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _oa:
'-------------------------------------------------------------------------------
    Data &H81       ' 0
    Data &HF3       ' 1
    Data &H49       ' 2
    Data &H61       ' 3
    Data &H33       ' 4
    Data &H25       ' 5
    Data &H05       ' 6
    Data &HF1       ' 7
    Data &H01       ' 8
    Data &H21       ' 9
'------------------------------
    Data &H0F       ' t  -  10
    Data &H0D       ' E  -  11
    Data &H25       ' S  -  12
    Data &H81       ' O  -  13
    Data &H19       ' P  -  14
    Data &H47       ' o  -  15
    Data &HFF       '   -  16
'-------------------------------------------------------------------------------
  _ok:
'-------------------------------------------------------------------------------
    Data &H7E       ' 0  -  0
    Data &H0C       ' 1  -  1
    Data &HB6       ' 2  -  2
    Data &H9E       ' 3  -  3
    Data &HCC       ' 4  -  4
    Data &HDA       ' 5  -  5
    Data &HFA       ' 6  -  6
    Data &H0E       ' 7  -  7
    Data &HFE       ' 8  -  8
    Data &HDE       ' 9  -  9
'------------------------------
    Data &HF0       ' t  -  10
    Data &HF2       ' E  -  11
    Data &HDA       ' S  -  12
    Data &H7E       ' O  -  13
    Data &HE6       ' P  -  14
    Data &HB8       ' o  -  15
    Data &H00       '   -  16

'-------------------------------------------------------------------------------
  _oa:
'-------------------------------------------------------------------------------
    Data &B00000000       '  
    Data &B00000001       ' 1
    Data &B00000010       ' 2
    Data &B00000100       ' 3
    Data &B00001000       ' 4
    Data &B00010000       ' 5
    Data &B00100000       ' 6
    Data &B01000000       ' 7
    Data &B10000000       ' 8
'-------------------------------------------------------------------------------
  _ok:       ' 
'-------------------------------------------------------------------------------
    Data &B11111111       '  
    Data &B11111110       ' 1
    Data &B11111101       ' 2
    Data &B11111011       ' 3
    Data &B11110111       ' 4
    Data &B11101111       ' 5
    Data &B11011111       ' 6
    Data &B10111111       ' 7
    Data &B01111111       ' 8
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------